<template lang="html">
  <butter-email ref="input" v-if='type == "email"' :value="value" :name="name" :label="label" :verify="verify" :placeholder="placeholder" :validated="validated" @validate="validate" @input="input" />
  <butter-checkbox ref="input" v-else-if='type == "checkbox"' :value="Boolean(value)" :link="link" :name="name" :label="label" @input="input" @browser-url="$emit('browser-url', $event)" />
  <div v-else-if='type == "countryState"'><slot @input="input" /></div>
  <butter-textarea ref="input" v-else-if="type == 'textarea'" :value="value" :label="label" :heading="heading" :copy="copy" :disabled="disabled" @input="input" />
  <butter-text-field ref="input" v-else :type="type" :value="value" :placeholder="placeholder" :name="name" :label="label" :disabled="disabled" @input="input" />
</template>

<script>
import { EVENT_INPUT } from '../lib/events'
export default {
  props: {
    'value': {
      type: String,
    },
    'type': {
      type: String,
    },
    'name': {
      type: String,
    },
    'label': {
      type: String,
    },
    'heading': {
      type: String,
    },
    'verify': {
      type: Boolean,
    },
    'placeholder': {
      type: String,
    },
    'link': {
      type: String,
    },
    'validated': {
      type: Boolean,
      default: false,
    },
    'disabled': {
      type: Boolean,
      default: false,
    },
    'copy': {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      internal: null,
    };
  },
  computed: {
  },
  methods: {
    validate(hash) {
      this.$emit('validate', hash);
    },
    input(value) {
      this.internal = value;
      return this.$emit(EVENT_INPUT, this.internal);
    },
  },
}
</script>
